/* WidgetUtils.c generated by valac 0.40.11, the Vala compiler
 * generated from WidgetUtils.vala, do not modify */

/* -*- Mode: Vala; indent-tabs-mode: nil; tab-width: 2 -*- */
/*
    This file is part of Déjà Dup.
    For copyright information, see AUTHORS.

    Déjà Dup is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Déjà Dup is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Déjà Dup.  If not, see <http://www.gnu.org/licenses/>.
*/


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <gdk/gdk.h>
#include "deja.h"

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _Block3Data Block3Data;
#define _g_free0(var) (var = (g_free (var), NULL))

struct _Block3Data {
	int _ref_count_;
	GtkWidget* w;
};



void deja_dup_show_uri (GtkWindow* parent,
                        const gchar* link);
void deja_dup_destroy_widget (GtkWidget* w);
gboolean deja_dup_user_focused (GtkWidget* win,
                                GdkEventFocus* e);
static gboolean _deja_dup_user_focused_gtk_widget_focus_in_event (GtkWidget* _sender,
                                                           GdkEventFocus* event,
                                                           gpointer self);
void deja_dup_show_background_window_for_shell (GtkWindow* win);
void deja_dup_hide_background_window_for_shell (GtkWindow* win);
static Block3Data* block3_data_ref (Block3Data* _data3_);
static void block3_data_unref (void * _userdata_);
static gboolean __lambda5_ (Block3Data* _data3_);
static gboolean ___lambda5__gsource_func (gpointer self);
gboolean deja_dup_gui_initialize (GtkWindow* parent,
                                  gboolean show_error);


void
deja_dup_show_uri (GtkWindow* parent,
                   const gchar* link)
{
	GError * _inner_error_ = NULL;
	g_return_if_fail (link != NULL);
	{
		gtk_show_uri_on_window (parent, link, gtk_get_current_event_time (), &_inner_error_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch6_g_error;
		}
	}
	goto __finally6;
	__catch6_g_error:
	{
		GError* e = NULL;
		GtkMessageDialog* dlg = NULL;
		GtkMessageDialog* _tmp0_;
		GtkMessageDialog* _tmp1_;
		GError* _tmp2_;
		const gchar* _tmp3_;
		GtkMessageDialog* _tmp4_;
		GtkMessageDialog* _tmp5_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp0_ = (GtkMessageDialog*) gtk_message_dialog_new (parent, GTK_DIALOG_DESTROY_WITH_PARENT | GTK_DIALOG_MODAL, GTK_MESSAGE_ERROR, GTK_BUTTONS_OK, _ ("Could not display %s"), link);
		g_object_ref_sink (_tmp0_);
		dlg = _tmp0_;
		_tmp1_ = dlg;
		_tmp2_ = e;
		_tmp3_ = _tmp2_->message;
		gtk_message_dialog_format_secondary_text (_tmp1_, "%s", _tmp3_);
		_tmp4_ = dlg;
		gtk_dialog_run ((GtkDialog*) _tmp4_);
		_tmp5_ = dlg;
		deja_dup_destroy_widget ((GtkWidget*) _tmp5_);
		_g_object_unref0 (dlg);
		_g_error_free0 (e);
	}
	__finally6:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}


static gboolean
_deja_dup_user_focused_gtk_widget_focus_in_event (GtkWidget* _sender,
                                                  GdkEventFocus* event,
                                                  gpointer self)
{
	gboolean result;
	result = deja_dup_user_focused (_sender, event);
	return result;
}


gboolean
deja_dup_user_focused (GtkWidget* win,
                       GdkEventFocus* e)
{
	gboolean result = FALSE;
	guint _tmp0_;
	g_return_val_if_fail (win != NULL, FALSE);
	g_return_val_if_fail (e != NULL, FALSE);
	gtk_window_set_urgency_hint (G_TYPE_CHECK_INSTANCE_CAST (win, gtk_window_get_type (), GtkWindow), FALSE);
	g_signal_parse_name ("focus-in-event", gtk_widget_get_type (), &_tmp0_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (win, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp0_, 0, NULL, (GCallback) _deja_dup_user_focused_gtk_widget_focus_in_event, NULL);
	result = FALSE;
	return result;
}


void
deja_dup_show_background_window_for_shell (GtkWindow* win)
{
	g_return_if_fail (win != NULL);
	gtk_window_set_focus_on_map (win, FALSE);
	gtk_window_set_urgency_hint (win, TRUE);
	g_signal_connect ((GtkWidget*) win, "focus-in-event", (GCallback) _deja_dup_user_focused_gtk_widget_focus_in_event, NULL);
	gtk_widget_show ((GtkWidget*) win);
}


void
deja_dup_hide_background_window_for_shell (GtkWindow* win)
{
	g_return_if_fail (win != NULL);
	gtk_widget_hide ((GtkWidget*) win);
}


static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}


static Block3Data*
block3_data_ref (Block3Data* _data3_)
{
	g_atomic_int_inc (&_data3_->_ref_count_);
	return _data3_;
}


static void
block3_data_unref (void * _userdata_)
{
	Block3Data* _data3_;
	_data3_ = (Block3Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data3_->_ref_count_)) {
		_g_object_unref0 (_data3_->w);
		g_slice_free (Block3Data, _data3_);
	}
}


static gboolean
__lambda5_ (Block3Data* _data3_)
{
	gboolean result = FALSE;
	gtk_widget_destroy (_data3_->w);
	result = FALSE;
	return result;
}


static gboolean
___lambda5__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda5_ (self);
	return result;
}


void
deja_dup_destroy_widget (GtkWidget* w)
{
	Block3Data* _data3_;
	GtkWidget* _tmp0_;
	g_return_if_fail (w != NULL);
	_data3_ = g_slice_new0 (Block3Data);
	_data3_->_ref_count_ = 1;
	_tmp0_ = _g_object_ref0 (w);
	_g_object_unref0 (_data3_->w);
	_data3_->w = _tmp0_;
	gtk_widget_hide (_data3_->w);
	g_object_ref ((GObject*) _data3_->w);
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda5__gsource_func, block3_data_ref (_data3_), block3_data_unref);
	block3_data_unref (_data3_);
	_data3_ = NULL;
}


gboolean
deja_dup_gui_initialize (GtkWindow* parent,
                         gboolean show_error)
{
	gboolean result = FALSE;
	gchar* header = NULL;
	gchar* msg = NULL;
	gboolean rv = FALSE;
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	gboolean _tmp2_;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_;
	_tmp2_ = deja_dup_initialize (&_tmp0_, &_tmp1_);
	_g_free0 (header);
	header = _tmp0_;
	_g_free0 (msg);
	msg = _tmp1_;
	rv = _tmp2_;
	_tmp4_ = rv;
	if (!_tmp4_) {
		_tmp3_ = show_error;
	} else {
		_tmp3_ = FALSE;
	}
	if (_tmp3_) {
		GtkMessageDialog* dlg = NULL;
		const gchar* _tmp5_;
		GtkMessageDialog* _tmp6_;
		GtkMessageDialog* _tmp7_;
		const gchar* _tmp8_;
		GtkMessageDialog* _tmp9_;
		GtkMessageDialog* _tmp10_;
		_tmp5_ = header;
		_tmp6_ = (GtkMessageDialog*) gtk_message_dialog_new (parent, GTK_DIALOG_DESTROY_WITH_PARENT | GTK_DIALOG_MODAL, GTK_MESSAGE_ERROR, GTK_BUTTONS_OK, "%s", _tmp5_);
		g_object_ref_sink (_tmp6_);
		dlg = _tmp6_;
		_tmp7_ = dlg;
		_tmp8_ = msg;
		gtk_message_dialog_format_secondary_text (_tmp7_, "%s", _tmp8_);
		_tmp9_ = dlg;
		gtk_dialog_run ((GtkDialog*) _tmp9_);
		_tmp10_ = dlg;
		deja_dup_destroy_widget ((GtkWidget*) _tmp10_);
		_g_object_unref0 (dlg);
	}
	result = rv;
	_g_free0 (msg);
	_g_free0 (header);
	return result;
}



